-- Instantiation d'un nouveau dissecteur
local proto = Proto("http-stat", "Statistiques du serveur Web")

-- Ajout de deux variables dans les préférences
local p = proto.prefs
p.logfile = Pref.string("Fichier Log", "", 
  "Chemin du fichier de statistiques")
local eval_enum = { { "Off", "Aucune sortie", 0 },
  { "Normal", "Normal", 1 },
  { "Verbose", "Verbeux", 2 } }
p.level = Pref.enum("Niveau", 1, "Niveau de verbosité", 
  eval_enum, true)

-- Création des champs du protocole
local f = proto.fields
f.file = ProtoField.string ("httpstat.file", "Nom du fichier")

local http_dissector = Dissector.get ("http")

-- La fonction principale du dissecteur
function proto.dissector (buffer, pinfo, tree)
  http_dissector:call (buffer, pinfo, tree)

  local request = buffer():string()
  local url = request:match("^GET (%S+) HTTP")
  if url then
    local subtree = tree:add (proto, buffer())
    subtree:add (f.file, url)
    pinfo.cols.file = url
  end
end

local packet_counter
-- Fonction d'initialisation du dissecteur
function proto.init ()
  packet_counter = 0
end

-- Enregistrement du dissecteur
local tcp_table = DissectorTable.get ("tcp.port")
tcp_table:add (8080, proto)

